/******************************************************************************
 *    SetObjectParamString.cpp
 *
 *    This file is part of Object Script Library
 *    Copyright (C) 2005-2007 Tom N Harris <telliamed@whoopdedo.org>
 *
 *    Permission is hereby granted, free of charge, to any person obtaining
 *    a copy of this software and associated documentation files (the 
 *    "Software"), to deal in the Software without restriction, including 
 *    without limitation the rights to use, copy, modify, merge, publish, 
 *    distribute, sublicense, and/or sell copies of the Software, and to 
 *    permit persons to whom the Software is furnished to do so.
 *    
 *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 *    OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-
 *    INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 
 *    BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN 
 *    AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR 
 *    IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
 *    THE SOFTWARE.
 *
 *****************************************************************************/

#include "ScriptLib.h"

#include <string.h>
#include <stdio.h>

int SetObjectParamString(int iObject, const char* pszParam, const char* pszVal)
{
	if (!pszParam || !pszVal)
		return 1;
	char* params = GetObjectParams(iObject);
	if (!params)
	{
		int iLen = 4 + strlen(pszParam) + strlen(pszVal);
		params = reinterpret_cast<char*>(g_pMalloc->Alloc(iLen + 1));
		if (!params)
			return 1;
		// You'll have to take care not to pass a string with un-escaped quotes.
		sprintf(params, "%s=\"%s\"", pszParam, pszVal);
	}
	else
	{
		char* newparams = SetParamString(params, pszParam, pszVal);
		g_pMalloc->Free(params);
		params = newparams;
	}
	int iRet = 1;
	if (params)
	{
		iRet = SetObjectParams(iObject, params);
		g_pMalloc->Free(params);
	}
	return iRet;
}
